<id>
Grudge:VisualWarning
</id>

<version>
1.32
</version>

<mod info>
DESCRIPTION
===========
This mod lets you to give visual warnings to your users in four stages:
  1) First warning - instant message and a green warning mark next to user name.
  2) Post moderation - the user's posts must be approved before they are seen.
  3) Mute - instant message and the inability to post polls or messages.
  4) Ban - user is gone. :D

Written by Matthew Wolf (aka Grudge) - January 2004
Updated to work with both SMF 1.0 and SMF v1.1 by Sheryl Canter (aka Permutations), July 2005. See version history for details.
Bugs cleared & updated to work with SMF 1.1 RC1 by xenovanis, November 2005.
Updated to work with SMF 1.1 RC2, SMF 1.1 RC3 and SMF 1.1 by Aaron, July 2006.
Bugs cleared & updated to work with SMF 1.1.1 and 1.1.2 by Eleglin, January - February 2007
</mod info>

<author>
Grudge
</author>

<homepage>
www.mymods.co.uk
</homepage>

<edit file>
$boarddir/index.php
</edit file>

<search for>
		// Log this user as online.
		writeLog();

</search for>
<add after>
		// Check if time to run visual warning update
		if ($modSettings['autoWarningTime'] < time())
			autoWarn();

</add after>

<search for>
		'viewquery' => array('ViewQuery.php', 'ViewQuery'),
</search for>
<add after>
		'warnadd' => array('VisualWarning.php', 'AddWarning'),
		'warnadd2' => array('VisualWarning.php', 'AddWarning2'),
		'warnlist' => array('VisualWarning.php', 'ListWarnings'),
		'warnlist2' => array('VisualWarning.php', 'ListWarnings2'),
		'warnpmman' => array('VisualWarning.php', 'Manager'),
		'warnpmman2' => array('VisualWarning.php', 'Manager2'),
</add after>

<edit file>
$sourcedir/ModSettings.php
</edit file>

<search for>
			array('text', 'karmaSmiteLabel'),
</search for>
<add after>
		array('heading', &$txt['visual_warning_mod']),
			array('text', 'visualw_mess_ban'),
			array('text', 'visualw_mess_mute'),
			array('text', 'visualw_mess_pmod'),
			array('text', 'visualw_mess_warn'),
		array('rule'),
			array('text', 'visualw_color_ban'),
			array('text', 'visualw_color_mute'),
			array('text', 'visualw_color_pmod'),
			array('text', 'visualw_color_warn'),
		array('rule'),
			array('text', 'visualw_image_ban'),
			array('text', 'visualw_image_mute'),
			array('text', 'visualw_image_pmod'),
			array('text', 'visualw_image_warn'),
		array('rule'),
			array('text', 'muteAutoTime'),
			array('text', 'moderationAutoTime'),
			array('text', 'warningAutoTime'),
		array('rule'),
			array('check', 'visualw_pmod_edit'),
</add after>

<edit file>
$themedir/Profile.template.php
</edit file>

<search for>
					<td colspan="2"><hr size="1" width="100%" class="hrcolor" /></td>
				</tr><tr>
					<td><b>', $txt[231], ': </b></td>
					<td>', $context['member']['gender']['name'], '</td>
</search for>
<add before>
';
if ($context['member']['warning']['link'] != '')
echo'
					<td><b>' . $txt['visual_current_level'] . ' </b></td>
					<td>' . $context['member']['warning']['link'] . '</td>
				</tr><tr>
';
echo'
</add before>

<edit file>
$sourcedir/Display.php
</edit file>

<search for>
	$context['can_reply'] &= empty($topicinfo['locked']) || allowedTo('moderate_board');
</search for>
<add after>
	$context['can_warn'] = allowedTo('visual_warn_any');
</add after>

<edit file>
$themedir/Display.template.php
</edit file>

<search for>
		if ($message['can_remove'])
			echo '
									<a href="', $scripturl, '?action=deletemsg;topic=', $context['current_topic'], '.', $context['start'], ';msg=', $message['id'], ';sesc=', $context['session_id'], '" onclick="return confirm(\'', $txt[154], '?\');">', ($settings['use_image_buttons'] ? '<img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/delete.gif" alt="' . $txt[121] . '" border="0" />' : $txt[31]), '</a>';
</search for>
<add after>
	if ($context['can_warn'])
			echo '
									<a href="', $scripturl, '?action=warnadd;topic=', $context['current_topic'], ';start=', $context['start'], ';user=', $message['member']['id'], ';msg=', $message['id'], '">', ($settings['use_image_buttons'] ? '<img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/im_visualw.gif" alt="' . $txt['visual_raise'] . '" border="0" />' : $txt['visual_warn']), '</a>';

</add after>

<search for>
		if (isset($message['member']['group']) && $message['member']['group'] != '')
			echo '
								', $message['member']['group'], '<br />';
</search for>
<add after>
		if (isset($message['member']['warning']['link']) && $message['member']['warning']['link'] != '')
			echo'
								', $message['member']['warning']['link'];
</add after>

<edit file>
$sourcedir/Post.php
</edit file>

<search for>
	$context['show_spellchecking'] = $modSettings['enableSpellChecking'] && function_exists('pspell_new');
</search for>
<add after>
	if ($user_info['warning'] > 2)
		fatal_error($txt['visual_been_muted']);
	if ($user_info['warning'] == 2)
		$context['warning'] = 1;
</add after>

<search for>
global $board, $topic, $txt, $db_prefix, $modSettings, $sourcedir, $context;
</search for>
<add after>
    global $scripturl, $threadid;
</add after>

<search for>
	require_once($sourcedir . '/Subs-Post.php');
	loadLanguage('Post');

</search for>
<add after>
	if ($user_info['warning'] > 2)
		fatal_error($txt['visual_been_muted']);
</add after>

<search for>
			$msgOptions['modify_time'] = time();
			$msgOptions['modify_name'] = addslashes($user_info['name']);
		}

		modifyPost($msgOptions, $topicOptions, $posterOptions);
	}
</search for>
<add after>
	// This is a new post, not an admin, user's posts are moderated - save it.
	elseif(!isset($_REQUEST['msg']) && !$user_info['is_admin'] && $user_info['warning'] == 2){
		$idtostore = $topic == null ? -1 : $topic;
		$request = db_query("
				INSERT INTO {$db_prefix}postmoderation 
				(ID_MEMBER, ID_TOPIC, ID_BOARD, subject, posterName, 
				posterEmail, posterTime, posterIP, body, icon,smiliesEnabled, ID_POLL)
				VALUES ($ID_MEMBER, '$idtostore', '$board', '$_POST[subject]', 
				'$_POST[guestname]', '$_POST[email]', " . time() . ", '$_SERVER[REMOTE_ADDR]',
				'$_POST[message]','$_POST[icon]', " . (isset($_POST['ns']) ? '0' : '1') . ", $ID_POLL)", __FILE__, __LINE__);
		if ($options['return_to_post'] == '1' && $topic != '')
			redirectexit("$scripturl?topic=$threadid;start=new");
		else
			redirectexit("$scripturl?board=$board");
	}
</add after>

<search for>
	// Editing a message...
	elseif (isset($_REQUEST['msg']))
	{
		checkSession('get');
</search for>
<add after>
		// Check user has no warnings on this message
		if ($user_info['warning'] > 1 && empty($modSettings['visualw_pmod_edit']))
			fatal_error($txt['visual_perm_modify']);
		if ($user_info['warning'] > 0){
			$request = db_query("
				SELECT warningText
				FROM {$db_prefix}vwarnings
				WHERE memberID=$ID_MEMBER
					AND messageID=$_REQUEST[msg] LIMIT 1", __FILE__, __LINE__);
			if (mysql_fetch_assoc($request))
				fatal_error($txt['visual_perm_modify']);
		}
</add after>

<search for>
	if (isset($_REQUEST['msg']) && !empty($topic))
	{
		$_REQUEST['msg'] = (int) $_REQUEST['msg'];
</search for>
<add after>
		// Check user has no warnings on this message
		if ($user_info['warning'] > 1 && empty($modSettings['visualw_pmod_edit']))
			fatal_error($txt['visual_perm_modify']);
		if ($user_info['warning'] > 0){
			$request = db_query("
				SELECT warningText
				FROM {$db_prefix}vwarnings
				WHERE memberID=$ID_MEMBER
					AND messageID=$_REQUEST[msg] LIMIT 1", __FILE__, __LINE__);
			if (mysql_fetch_assoc($request))
				fatal_error($txt['visual_perm_modify']);
		}
</add after>

<search for>
		// Permissions check!
		isAllowedTo('calendar_post');
</search for>
<add after>
		// warning
		if ($user_info['warning'] > 1)
			fatal_error($txt['visual_postmod_auth']);
</add after>

<edit file>
$themedir/Post.template.php
</edit file>

<search for>
	if ($context['can_post_attachment'])
</search for>
<replace>
	if (isset($context['warning']))
	echo'
		<tr>
			<td align="center" colspan="2">
				<font size="2">' . $txt['visual_postmod_appear'] . '</font>
			</td>
		</tr>';
	elseif ($context['can_post_attachment'])
</replace>

<edit file>
$sourcedir/Karma.php
</edit file>

<search for>
	// If you're a guest or can't do this, blow you off...
	is_not_guest();
</search for>
<add after>
	// If you have ANY warning, also blow you off
	if ($user_info['warning'] > 1)
		fatal_error($txt['visual_no_karma']);
</add after>

<edit file>
$sourcedir/Subs.php
</edit file>

<search for>
		if (allowedTo('moderate_forum'))
			$context['admin_areas']['members']['areas']['view_members'] = '<a href="' . $scripturl . '?action=viewmembers">' . $txt[5] . '</a>';
</search for>
<replace>
		if (allowedTo('moderate_forum'))
		{
			$context['admin_areas']['members']['areas']['view_members'] = '<a href="' . $scripturl . '?action=viewmembers">' . $txt[5] . '</a>';
			$context['admin_areas']['members']['areas']['warning_manager'] = '<a href="' . $scripturl . '?action=warnlist">' . $txt['visual_warning_management'] . '</a>';
			$context['admin_areas']['members']['areas']['postmod_manager'] = '<a href="' . $scripturl . '?action=warnpmman">' . $txt['visual_postmod_manager'] . '</a>';
		}
</replace>

<search for>
		$context['user']['unread_messages'] = &$user_info['unread_messages'];
</search for>
<add after>
		if (allowedTo('visual_approve_any'))
		{
			$result = db_query("
					SELECT COUNT(*) 
					FROM {$db_prefix}postmoderation", __FILE__, __LINE__);
			list($modmsg) = mysql_fetch_row($result);
			if ($modmsg)
				$context['user']['awaiting_mod'] = $modmsg . ' ' . $txt['visual_require_mod'];
		}
</add after>

<search for>
function setupThemeContext()
{
	global $modSettings, $user_info, $scripturl, $context, $settings, $options, $txt, $maintenance;
</search for>
<add after>
	global $db_prefix; // Grudge's Mod
</add after>

<edit file>
$sourcedir/Security.php
</edit file>

<search for>
// Do banning related stuff.  (ie. disallow access....)
function is_not_banned($forceCheck = false)
</search for>
<add before>
function autoWarn()
{
	global $txt, $db_prefix, $modSettings, $sourcedir;

	loadLanguage('PersonalMessage');

	// Only check warning levels once every blue moon
	updateSettings(array('autoWarningTime' => time() + 86400));
	$request = db_query("
			SELECT ID, memberID, timeToWarn, time, level
			FROM {$db_prefix}vwarnings WHERE level < 4 AND level > 0", __FILE__, __LINE__);
	include_once($sourcedir . '/Subs-Post.php');
	while ($row = mysql_fetch_assoc($request)){
		$IM=0;
		if($row['timeToWarn'] == -1){
			// Check if time is expired
			if ($row['level'] == 1)
				$timeinc = $modSettings['warningAutoTime']*86400;
			elseif ($row['level'] == 2)
				$timeinc = $modSettings['moderationAutoTime']*86400;
			else
				$timeinc = $modSettings['muteAutoTime']*86400;
		}
		else
			$timeinc = $row['timeToWarn']*86400;
		if(time() > $row['time'] + $timeinc){
			db_query("
				UPDATE {$db_prefix}vwarnings
				SET level = level - 1, time = " . time() . "
				WHERE ID=$row[ID]", __FILE__, __LINE__);
			db_query("
				UPDATE {$db_prefix}members
				SET warning=warning - 1 
				WHERE ID_MEMBER=$row[memberID]",__FILE__, __LINE__);
			$IM=1;
		}
		if ($IM==1){
			$result = db_query("
					SELECT memberName, ID_MEMBER, emailAddress
					FROM {$db_prefix}members
					WHERE ID_MEMBER=$row[memberID]", __FILE__, __LINE__);
			list($nameTo, $toID, $emailTo) = mysql_fetch_row($result);
			$result = db_query("
				SELECT ID_MEMBER, realName, memberName FROM {$db_prefix}members
				WHERE ID_GROUP=1 LIMIT 1", __FILE__, __LINE__);
			$fromInfo = mysql_fetch_row($result);
			$from = array(
				'id' => $fromInfo[0],
				'name' => $fromInfo[1],
				'username' => $fromInfo[2],
			);
			$immessage = $nameTo . "\n\n" . $txt['visual_warning_reduced'];
			sendpm($toID, null, $txt['visual_reduced'], $immessage, $from);
		}
	}
}
</add before>

<edit file>
$languagedir/Modifications.english.php
</edit file>

<search for>
?>
</search for>
<add before>
$txt['visual_warning_mod']='Visual Warning Mod';
$txt['visualw_mess_ban']='Message To Show For Banned User';
$txt['visualw_mess_mute']='Message To Show For Muted User';
$txt['visualw_mess_pmod']='Message To Show For Post Moderated User';
$txt['visualw_mess_warn']='Message To Show For Warned User';
$txt['visualw_color_ban']='Color of Message For Banned User';
$txt['visualw_color_mute']='Color of Message For Muted User';
$txt['visualw_color_pmod']='Color of Message For Post Moderated User';
$txt['visualw_color_warn']='Color of Message For Warned User';
$txt['visualw_image_ban']='Image to Show For Banned User';
$txt['visualw_image_mute']='Image to Show For Muted User';
$txt['visualw_image_pmod']='Image to Show For Post Moderated User';
$txt['visualw_image_warn']='Image to Show For Warned User';
$txt['warningAutoTime']='Default Time Before Warning Removed (Days):';
$txt['moderationAutoTime']='Default Time Before Moderation Removed (Days):';
$txt['muteAutoTime']='Default Time Before Mute Removed (Days):';
$txt['visualw_pmod_edit']='Moderated Users May Edit Messages:';
$txt['visual_require_mod'] = 'messages require moderation';
$txt['visual_raise']='Raise Warning Level';
$txt['visual_no_perm']='You Do Not Have Permission To Raise Warning Levels';
$txt['visual_no_warnings']='User has NO Current Warnings!';
$txt['visual_prev_warning']='Previous Warning Details';
$txt['visual_current_level']='Current Level:';
$txt['visual_topic_raised']='Topic Where Raised:';
$txt['visual_time_raised']='Time When Raised:';
$txt['visual_reason_raised']='Reason For Raise:';
$txt['visual_level_details']='New Level Details';
$txt['visual_submit']='Submit';
$txt['visual_new_level']='New Level:';
$txt['visual_warning_management']='Warning Management';
$txt['visual_list_desc']='This lists all users that currently have some form of warning (levels 1,2 or 3. Level 4 is not listed as these members have already been banned! You can choose to mass reduce members here or click the member to adjust level accordingly';
$txt['visual_member']='Member';
$txt['visual_level']='Level';
$txt['visual_reason']='Reason';
$txt['visual_when']='When';
$txt['visual_text_warn']='Warned';
$txt['visual_warn']='Warn';
$txt['visual_perm_modify']='You Do Not Have Permission To Modify This Message';
$txt['visual_official_warning']='You Have Received an Offical Warning';
$txt['visual_received_warning']='You have received a warning for recent conduct on our message board. Please follow the link below for more information:';
$txt['visual_been_muted']='You Have Been Muted Due To Bad Behaviour';
$txt['visual_no_karma']='You May Not Give Karma Whilst Warned';
$txt['visual_stages']='(0=None, 1=Warned, 2=Moderated, 3=Muted. 4=Banned)';
$txt['visual_text_pmod']='Moderated';
$txt['visual_text_mute']='Muted';
$txt['visual_text_ban']='Banned';
$txt['visual_none']='None';
$txt['visual_warning_increased']='I have to inform you that your warning level on the board has been increased.';
$txt['visual_warning_reduced']='I am pleased to announce that your warning level on the board has been reduced.';
$txt['visual_reduced']='Warning level reduced';
$txt['visual_lasts']='Time Warning Lasts (Blank=Default)';
$txt['visual_postmod_manager']='Post Moderation Manager';
$txt['visual_postmod_user_under']='This User Is Currently Having All Theirs Posts Approved Before Posting';
$txt['visual_postmod_under']='You Are Currently Under Post Moderation';
$txt['visual_postmod_not']='This User Is Not Post Moderated';
$txt['visual_postmod_is']='This User Is Post Moderated';
$txt['visual_postmod_change']='Change This User\'s Status';
$txt['visual_postmod']='Post Moderation';
$txt['visual_postmod_auth']='You are not authorised to perform this action!';
$txt['visual_postmod_appear']='You Are Currently Under Post Moderation - Your Post Will Appear After Approval';
$txt['visual_postmod_awaiting']='These are all the posts awaiting moderation. To approve a posts (or posts) check all the messages you wish to approve and select "Approve" to delete messages off select those messages you wish to delete and select "Delete"';
$txt['visual_postmod_username']='Username';
$txt['visual_postmod_subject']='Subject/Message';
$txt['visual_postmod_approve']='Approve';
$txt['visual_postmod_delete']='Delete';
$txt['permissiongroup_visual_warn']='Give warnings and perform post moderation';
$txt['permissionname_visual_warn_any']='Warn users';
$txt['permissionname_visual_approve_any']='Approve posts';
</add before>

<edit file>
$sourcedir/ManagePermissions.php
</edit file>

<search for>
			'profile' => array(
				'profile_view' => true,
				'profile_identity' => true,
				'profile_extra' => true,
				'profile_title' => true,
				'profile_remove' => true,
				'profile_remote_avatar' => false,
			)
</search for>
<add after>
			,
			'visual_warn' => array(
				'visual_warn_any' => false,
				'visual_approve_any' => false,
			)
</add after>

<edit file>
$themedir/index.template.php
</edit file>

<search for>
		// Is the forum in maintenance mode?
		if ($context['in_maintenance'] && $context['user']['is_admin'])
			echo '
							<b>', $txt[616], '</b><br />';
</search for>
<add after>
		if (isset($context['user']['awaiting_mod']))
			echo '<br />' . $context['user']['awaiting_mod'];

</add after>

<edit file>
$sourcedir/Load.php
</edit file>

<search for>
			mem.birthdate, mem.memberIP, mem.ICQ, mem.AIM, mem.YIM, mem.MSN, mem.posts, mem.lastLogin,
</search for>
<add after>
			mem.warning, " . "
</add after>

<search for>
			mem.karmaBad, mem.memberIP, mem.lngfile, mem.ID_GROUP, mem.ID_THEME, mem.buddy_list, mem.pm_ignore_list,
</search for>
<add after>
			mem.warning, " . "" . "
</add after>

<search for>
		'email' => isset($user_settings['emailAddress']) ? $user_settings['emailAddress'] : '',
</search for>
<add after>
		'warning' => isset($user_settings['warning']) ? $user_settings['warning'] : 0,
</add after>

<search for>
		'aim' => $profile['AIM'] != '' && (empty($modSettings['guest_hideContacts']) || !$user_info['is_guest']) ? array(
</search for>
<add before>
		'warning' => $profile['warning'] > 0 ? array(
			'link' => ($modSettings['visualw_image_' . $warn] != "" ? '<img src="' . $settings['images_url'] . '/' . $modSettings['visualw_image_' . $warn] . '"/>' : '') . 
			($modSettings['visualw_color_' . $warn] != "" ? '<font size="2" color="' . $modSettings['visualw_color_' . $warn] . '">
			 ' . $txt['visual_text_' . $warn] . '</font>' : '') . '<br />',
		) : array('link' => ''),
</add before>

<search for>
	$profile['signature'] = parse_bbc($profile['signature'], true, 'sig' . $profile['ID_MEMBER']);
</search for>
<add after>
	if ($profile['warning'] == 1)
		$warn = 'warn';
	elseif ($profile['warning'] == 2)
		$warn = 'pmod';
	elseif ($profile['warning'] == 3)
		$warn = 'mute';
	elseif ($profile['warning'] == 4)
		$warn = 'ban';
</add after>
