<?php
/******************************************************************************
* VisualWarningdb.php                                                         *
*******************************************************************************
* SMF: Simple Machines Forum - Visual Warning MOD                             *
* Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                *
* =========================================================================== *
* Software Version:           1.0	                                      *
* Software by:                Matthew Wolf (a.k.a Grudge)		      *
* Support, News, Updates at:  http://www.simplemachines.org                   *
*******************************************************************************
* This program is free software; you may redistribute it and/or modify it     *
* under the terms of the provided license as published by Lewis Media.        *
*                                                                             *
* This program is distributed in the hope that it is and will be useful,      *
* but WITHOUT ANY WARRANTIES; without even any implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
*                                                                             *
* See the "license.txt" file for details of the Simple Machines license.      *
* The latest version can always be found at http://www.simplemachines.org.    *
******************************************************************************/
$toSet = array();
// This is in all installations
$toSet['visualw_pmod_edit'] = 0;
$toSet['visualw_color_pmod'] = 'yellow';
$toSet['visualw_image_pmod'] = 'warnpmod.gif';
$toSet['visualw_mess_pmod'] = 'This User Has Now Had Their Posts Moderated';
$toSet['moderationAutoTime'] = 7;
$toSet['muteAutoTime'] = 7;
$toSet['warningAutoTime'] = 3;
$toSet['autoWarningTime'] = 0;
$toSet['visualw_color_warn'] = 'green';
$toSet['visualw_image_warn'] = 'warnwarn.gif';
$toSet['visualw_mess_warn'] = 'This User Has Received An Official Warning';
$toSet['visualw_color_mute'] = 'orange';
$toSet['visualw_image_mute'] = 'warnmute.gif';
$toSet['visualw_mess_mute'] = 'This User Has Been Muted';
$toSet['visualw_color_ban'] = 'red';
$toSet['visualw_image_ban'] = 'warnban.gif';
$toSet['visualw_mess_ban'] = 'This User Has Been Banned';

// Insert the settings.
foreach ($toSet as $key => $value)
	db_query("
		INSERT IGNORE INTO {$db_prefix}settings
		(`variable`, `value`)
		VALUES ('$key', '$value')", __FILE__, __LINE__);

// This can always be done.
db_query("CREATE TABLE IF NOT EXISTS {$db_prefix}postmoderation
		(ID INT(11) NOT NULL AUTO_INCREMENT,
		ID_TOPIC INT(11),
		ID_BOARD INT(11),
		ID_MEMBER INT(11) NOT NULL DEFAULT '0',
		subject TINYTEXT,
		posterName TINYTEXT,
		posterEmail TINYTEXT,
		posterTime BIGINT(20),
		posterIP TINYTEXT NOT NULL,
		smiliesEnabled TINYINT(4) NOT NULL DEFAULT '1',
		body TEXT, icon TINYTEXT,
		ID_POLL INT(11) DEFAULT '-1', 
		PRIMARY KEY (ID)) TYPE = MYISAM COMMENT = 'Visual Warning Post Moderation'", __FILE__, __LINE__);

// Work out what we already have installed!
$request = db_query("
	SHOW TABLES LIKE '{$db_prefix}vwarnings'", __FILE__, __LINE__);
$new = mysql_num_rows($request) == 0;

// Never been installed
if ($new)
{
	 db_query("CREATE TABLE IF NOT EXISTS {$db_prefix}vwarnings
		(ID INT(11) NOT NULL AUTO_INCREMENT,
		memberID INT(11) NOT NULL,
		MessageID INT(11) NOT NULL,
		warningText TEXT  NOT NULL,
		time INT(11) DEFAULT '0' NOT NULL,
		level INT(3) NOT NULL,
		timeToWarn INT(3) DEFAULT '-1',
		PRIMARY KEY (ID)) TYPE = MYISAM COMMENT = 'Visual Warning Table'", __FILE__, __LINE__);
	db_query("
		ALTER TABLE {$db_prefix}members
		ADD warning INT", __FILE__, __LINE__);
}
// Has been...
else
{
	// See if they already have the new column.
	$request = db_query("
		SHOW COLUMNS
		FROM {$db_prefix}vwarnings
		LIKE 'ID'", __FILE__, __LINE__);
	$need_add = mysql_num_rows($request) == 0;
	if ($need_add)
		db_query("
			ALTER TABLE {$db_prefix}vwarnings
			ADD TimeToWarn INT(3) DEFAULT '-1'", __FILE__, __LINE__);
}

?>

